#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define N 7
typedef struct book {
    char author_n[20];
    char author_f[20];
    char title[20];
    int year;
    int pages;
    float price;
    struct book* next;
} book;

void insert(book* head, book* new_book) {
    if (head == NULL) {
        new_book->next = head;
        head = new_book;
    }
    else {
        book* current = head;
        while (current->next != NULL) {
            current = current->next;
        }
        new_book->next = current->next;
        current->next = new_book;
    }
}

void swap(book* a, book* b) {
    char temp_author_n[20], temp_author_f[20], temp_title[20];
    int temp_year, temp_pages;
    float temp_price;
    
    strcpy(temp_author_n, a->author_n);
    strcpy(temp_author_f, a->author_f);
    strcpy(temp_title, a->title);
    temp_year = a->year;
    temp_pages = a->pages;
    temp_price = a->price;
    
    strcpy(a->author_n, b->author_n);
    strcpy(a->author_f, b->author_f);
    strcpy(a->title, b->title);
    a->year = b->year;
    a->pages = b->pages;
    a->price = b->price;
    
    strcpy(b->author_n, temp_author_n);
    strcpy(b->author_f, temp_author_f);
    strcpy(b->title, temp_title);
    b->year = temp_year;
    b->pages = temp_pages;
    b->price = temp_price;
}

void sort(book* head) {
    book* i;
    book* j;
    for (i = head; i != NULL; i = i->next) {
        for (j = i->next; j != NULL; j = j->next) {
            if (strcmp(i->author_f, j->author_f) > 0) {
                swap(i, j);
            }
        }
    }
}

void print_table(book* head) {
    printf("|  %-20s | %-20s | %-10s | %-15s | %-10s |\n", "Author", "Title", "Year", "Pages", "Price");
    printf("|-----------------------|----------------------|------------|-----------------|------------|\n");
    while (head != NULL) {
        printf("| %-10s %-10s | %-20s | %-10d | %-15d | %-10.2f |\n", head->author_n, head->author_f, head->title, head->year, head->pages, head->price);
        head = head->next;
    }
}
book* newest(book* head) {
    book* ptr = head;
    book* rstart = head;
    for (int i = 0; i < N; i++) {
        if (ptr->year < head->year) {
            rstart = head->next;
            struct book* tempnext = ptr->next;
            ptr->next = head;
            head->next = tempnext;
            break;
        }
        ptr = ptr->next;
    }
    return rstart;
}
void insert_new(book** first, book* insert_n) {
    if (strcmp(insert_n->author_f, (*first)->author_f) < 0) {
        insert_n->next = *first;
        first = &insert_n;
        printf("wow");
        return;
    }
    struct book* here = *first;
    struct book* curp = (*first)->next;
    while (curp) {
        if (strcmp(insert_n->author_f, curp->author_f) < 0) {
            here = curp;
        }
        curp = curp->next;
    }
    insert(here, insert_n);
}
void delete_c(book* head) {
    book* current = head;
    book* prev = NULL;
    while (current != NULL) {
        if (current->pages < 50) {
            if (prev == NULL) {
                head = current->next;
            }
            else {
                prev->next = current->next;
            }
            free(current);
            current = prev;
        }
        prev = current;
        current = current->next;
    }
}
int main() {
    book* head = NULL;
    FILE* fp;
    char author_n[20], author_f[20], title[20];
    int year, pages;
    float price;
    fp = fopen("BOOKs.txt", "r");
    if (fp == NULL)fp = fopen("BOOKS.txt", "r");
    if (fp == NULL) {
        printf("Error opening file\n");
        return 1;
    }
    while (fscanf(fp, "%s %s %s %d %d %f", author_n, author_f, title, &year, &pages, &price) != EOF) {
        book* new_book = malloc(sizeof(book));
        if (new_book == NULL) {
            printf("Error allocating memory\n");
            return 2;
        }
        strcpy(new_book->author_n, author_n);
        strcpy(new_book->author_f, author_f);
        strcpy(new_book->title, title);
        new_book->year = year;
        new_book->pages = pages;
        new_book->price = price;
        new_book->next = NULL;
        insert(head, new_book);
    }
    fclose(fp);
    printf("Data first\n");
    print_table(head);
    sort(head);
    printf("Data after sortingn");
    print_table(head);
    head = newest(head);
    printf("Nevest books\n");
    print_table(head);
    
    book* new_booca = malloc(sizeof(book));
    scanf("%s %s %s %d %d %f", new_booca->author_n, new_booca->author_f, new_booca->title, &new_booca->year, &new_booca->pages, &new_booca->price);
    
    insert_new(&head, new_booca);
    printf("\nWith added new bookn");
    print_table(head);
    delete_c(&head);
    printf("\nBooks after deleting those with less than 50 pagesn");
    print_table(head);
    
    return 0;
}
